<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
  <div class="container">
    <h2>Registration Car Form</h2>

    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-fname">First Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="input-fname" name="firstname" placeholder="Your first name ..." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-lname">Last Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="input-lname" name="lastname" placeholder="Your last name ..." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="country-select">Country</label>
        </div>
        <div class="col-sm-3">
          <select id="country-select" name="country" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="region-type-select">Region</label>
        </div>
        <div class="col-sm-3">
          <select id="region-type-select" name="region" class="form-control">
          </select>
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="car-select">Car</label>
        </div>
        <div class="col-sm-3">
          <select id="car-select" name="car" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="car-type-select">Car type</label>
        </div>
        <div class="col-sm-3">
          <select id="car-type-select" name="car-type" class="form-control">
          </select>
        </div>
      </div>
      <div class="row">
        <div class="col-sm-12" style="text-align: right;">
          <button class="btn btn-info" id="btn-send"> Send </button>
        </div>
      </div>
    </div>
  </div>
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // car brand information
  var gJsonCarData = `[
                          {"brandId": "0","brandName": "None", "brandTypes": []}, 
                          {"brandId": "1","brandName": "Audi", "brandTypes": [{"typeId":"0", "typeName":"Q3"},{"typeId":"1","typeName":"Q5"},{"typeId":"2","typeName":"A4"}]},
                          {"brandId": "2","brandName": "BMW", "brandTypes": [{"typeId":"0","typeName":"1 series"},{"typeId":"1","typeName":"X series"},{"typeId":"2","typeName":"Z series"}]},
                          {"brandId": "3","brandName": "Citroen", "brandTypes": [{"typeId":"0","typeName":"new C3"},{"typeId":"1","typeName":"C4"},{"typeId":"2","typeName":"BERLINGO"}]}
                        ]`;

  // country information
  var gJsonCountryData = `[
                            {"countryId": "0","countryName": "None", "regionTypes": []}, 
                            {"countryId": "1","countryName": "Việt nam", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0", "regionName":"Hà Nội"},
                                                                          {"regionId":"1","regionName":"Hồ Chí Minh"},
                                                                          {"regionId":"2","regionName":"Đà Nẵng"}]},
                            {"countryId": "2","countryName": "Mỹ", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Atlanta"},
                                                                          {"regionId":"1","regionName":"New York"},
                                                                          {"regionId":"2","regionName":"Boston"}
                                                                        ]},
                            {"countryId": "3","countryName": "Phần lan", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Nam Phần Lan"},
                                                                          {"regionId":"1","regionName":"Tây Phần Lan"},
                                                                          {"regionId":"2","regionName":"Đông Phần Lan"}
                                                                        ]}
                          ]`;

  var gObjectCarData = JSON.parse(gJsonCarData);
  var gObjectCountryData = JSON.parse(gJsonCountryData);

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function () {
    onPageLoading();
  });

  $("#car-select").on("change", function () {
    onCarSelectChange(this);
  })
  $("#country-select").on("change", function(){
    onCountrySelectChange(this);
  })

  $("#btn-send").click(function(){
    onBtnSendClick();
  })
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading() {
    loadDataToSelectCar();
    loadDataToSelectCountry();
  }
  //hàm sử lý sự kiện change select
  function onCarSelectChange(paramCarSelect) {
    var vBrandId = $("#car-select").val();
    console.log(vBrandId);

    //load dữ liệu ra car type
    loadDataToSelectCarType(vBrandId);
  }

  function onCountrySelectChange(paramCountrySelect){
    var vCountryId = $("#country-select").val();
    console.log(vCountryId);

    loadDataToSelectCountryType(vCountryId);
  }

  function onBtnSendClick(){
    var vCarObject = {
      brandId: -1,
      brandName: "",
      typeId: -1,
      typeName: "",
      countryId: "",
      countryName: "",
      regionId: "",
      regionName: "",
    }
    getCarObjectData(vCarObject);

    //kiem tra du lieu
    var vValid = validateCarData(vCarObject);

    if (vValid){
      sendCarData(vCarObject);
    }
  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  /**
   * hàm dữ liệu load select car
  **/
  function loadDataToSelectCar() {
    var vCarSelect = $("#car-select");
    for (var bI = 0; bI < gObjectCarData.length; bI++) {
      $("<option/>", {
        "value": gObjectCarData[bI].brandId,
        "text": gObjectCarData[bI].brandName
      }).appendTo($("#car-select"));
    }
  }
  // hamf dữ liệu load select country
  function loadDataToSelectCountry() {
    var vCountrySelect = $("#country-select");
    for (var bI = 0; bI < gObjectCountryData.length; bI++) {
      $("<option/>", {
        "value": gObjectCountryData[bI].countryId,
        "text": gObjectCountryData[bI].countryName
      }).appendTo($("#country-select"));
    }
  }

  //hàm load dữ liệu lên select car type
  function loadDataToSelectCarType(paramBrandId) {
    var vBrandType = getBrandTypeByBrandID(paramBrandId);

    var vCarSelectType =  $("#car-type-select");
    vCarSelectType.html("");

    if (vBrandType.length == 0) {
      vCarSelectType.prop("disabled", "disabled");

    } else {
      vCarSelectType.prop("disabled", false);
    }

    for (var bI = 0; bI < vBrandType.length; bI++){
      $("<option/>", {
        "value": vBrandType[bI].typeId,
        "text": vBrandType[bI].typeName
      }).appendTo(vCarSelectType);
    }

  }

  function loadDataToSelectCountryType(paramCountryId) {

    var vRegionType = getRegionTypeByCountryID(paramCountryId);

    var vRegionSelectType =  $("#region-type-select");
    vRegionSelectType.html("");

    if (vRegionType.length == 0) {
      vRegionSelectType.prop("disabled", "disabled");

    } else {
      vRegionSelectType.prop("disabled", false);
    }

    for (var bI = 0; bI < vRegionType.length; bI++){
      $("<option/>", {
        "value": vRegionType[bI].regionId,
        "text": vRegionType[bI].regionName
      }).appendTo(vRegionSelectType);
    }

  }
  /**
   * get brandType by brandId
   * input: brandId of a car
   * output: brandType name of found car. If not found, it returns null
   */
  function getBrandTypeByBrandID(paramBrandId) {
    var vBrandFound = false;
    var vBrandTypesResult = null;
    var vIterator = 0;
    while (!vBrandFound && vIterator < gObjectCarData.length) {
      if (gObjectCarData[vIterator].brandId === paramBrandId) {
        vBrandFound = true;
        vBrandTypesResult = gObjectCarData[vIterator].brandTypes;
      }
      else {
        vIterator++;
      }
    }
    return vBrandTypesResult;
  }

  function getRegionTypeByCountryID(paramCountryId) {
    var vRegionFound = false;
    var vRegionTypesResult = null;
    var vIterator = 0;
    while (!vRegionFound && vIterator < gObjectCountryData.length) {
      if (gObjectCountryData[vIterator].countryId === paramCountryId) {
        vRegionFound = true;
        vRegionTypesResult = gObjectCountryData[vIterator].regionTypes;
      }
      else {
        vIterator++;
      }
    }
    return vRegionTypesResult;
  }

  //ham thu thap du lieu
  function getCarObjectData(paramCarObject){
    paramCarObject.brandId = $("#car-select").val();
    paramCarObject.brandName =  $("#car-select option:selected").text();
    paramCarObject.typeId = $("#car-type-select").val();
    paramCarObject.typeName = $("#car-type-select option:selected").text();
    paramCarObject.countryId = $("#country-select").val();
    paramCarObject.countryName = $("#country-select options:selected").text();
    paramCarObject.regionId = $("#region-type-select").val();
    paramCarObject.regionName = $("#region-type-select option:selected").text();

  }

  function validateCarData(paramCarObject){
    if (paramCarObject.brandId == 0){
      alert("Phải chọn car!");
      $("#car-select").focus;
      return false;
    }
    if (paramCarObject.countryId == 0){
      alert("Phải chọn country!");
      $("#country-select").focus;
      return false;
    }
    else{
      return true;
    }
  }

  function sendCarData(paramCarObject){
    console.log(paramCarObject);
    console.log("countryId: " + paramCarObject.countryId);
    console.log("CountryName: " + paramCarObject.countryName);
    console.log("RegionId: " + paramCarObject.regionId);
    console.log("regionName: " + paramCarObject.regionName);
  }
</script>

</html>